<?php
/* 	OpenDb - Open Lending Database Project
	Copyright (C) 2001,2002 by Jason Pell

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

include_once("./functions/borrowed_item.php");

/*
* Only sofar as the s_status_type exists!
*/
function is_valid_s_status_type($s_status_type)
{
	$query = "SELECT 'X' FROM s_status_type WHERE s_status_type = '$s_status_type'";
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
	{
		mysql_free_result($result);
		return TRUE;
	}

	//else
	return FALSE;
}

/*
*/
function fetch_newitem_status_type_rs($owner_id)
{
	$user_type_r = get_min_user_type_r(fetch_user_type($owner_id));
	if(is_not_empty_array($user_type_r))
		$in_clause = format_sql_in_clause($user_type_r);
		
	$query = "SELECT sst.s_status_type as value, sst.description as display, sst.img, sst.default_ind as checked_ind  ".
			"FROM s_status_type sst ".
			"WHERE sst.closed_ind <> 'Y' AND ".
			"sst.insert_ind = 'Y' AND ".
			"(LENGTH(IFNULL(sst.min_create_user_type,'')) = 0 OR ".
			"sst.min_create_user_type IN($in_clause) ) ".
			"ORDER BY 1 ASC";
		
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
		return $result;
	else
		return FALSE;
}

/*
* Update an existing item_instance
*/
function fetch_update_status_type_rs($item_id, $instance_no, $owner_id)
{
	function get_status_type_in_clause($query)
	{
		$result = run_opendb_query($query);
		if($result && mysql_num_rows($result)>0)
		{
			$inclause = "";
			while($status_type_r = mysql_fetch_array($result))
			{
				if(strlen($inclause)>0)
					$inclause .= ",";
				$inclause .= "'".$status_type_r['s_status_type']."'";
			}
	
			if(strlen($inclause)>0)
				return "$inclause";
		}
		return FALSE;
	}

	$owner_in_clause = get_status_type_in_clause(
				"SELECT DISTINCT sst.s_status_type ".
				"FROM	s_status_type sst, ".
						"item_instance ii ".
				"WHERE	sst.s_status_type = ii.s_status_type AND ".
						"ii.item_id = '$item_id' AND ".
						"ii.owner_id = '$owner_id' AND ".
						"ii.instance_no <> '$instance_no'");
	
	$not_owner_in_clause = get_status_type_in_clause(
				"SELECT DISTINCT sst.s_status_type ".
				"FROM	s_status_type sst, ".
						"item_instance ii ".
				"WHERE	sst.s_status_type = ii.s_status_type AND ".
						"ii.item_id = '$item_id' AND ".
						"ii.owner_id <> '$owner_id'");
	
	$user_type_r = get_min_user_type_r(fetch_user_type($owner_id));
	if(is_not_empty_array($user_type_r))
		$in_clause = format_sql_in_clause($user_type_r);

	$status_type_r = fetch_status_type_r(fetch_item_s_status_type($item_id, $instance_no));
	
	// If a borrow record already exists for a record, then can only reset item s_status_type
	// to one where borrows are allowed (borrow_ind=Y), or temporarily disabled (borrow_ind=N),
	// but not completely disallowed. (borrow_ind=X)
	if(is_item_borrowed($item_id, $instance_no))
		$borrow_clause = "borrow_ind IN('Y','N') ";	
	else if(is_exists_item_instance_borrowed_item($item_id, $instance_no))
		$borrow_clause = "borrow_ind IN('Y','N','B') ";	
		
	$query = "SELECT DISTINCT sst.s_status_type as value, sst.description as display, sst.img, sst.default_ind as checked_ind ".
			"FROM s_status_type sst ".
			"WHERE sst.s_status_type = '".$status_type_r['s_status_type']."' OR ".
				"(sst.closed_ind <> 'Y' AND ".
				"sst.update_ind = 'Y' AND ".
				(strlen($borrow_clause)>0?" $borrow_clause AND ":"").
				"(LENGTH(IFNULL(sst.min_create_user_type,'')) = 0 OR ".
				"sst.min_create_user_type IN($in_clause)) ";
				
	if(strlen($owner_in_clause)>0)
	{
		$query .= "AND (sst.new_owner_instance_ind = 'Y' OR sst.s_status_type NOT IN ($owner_in_clause)) ";
	}
	
	if(strlen($not_owner_in_clause)>0)
	{
		$query .= "AND (sst.new_not_owner_instance_ind = 'Y' OR sst.s_status_type NOT IN ($not_owner_in_clause))";
	}
		
	$query .= ") ORDER BY 1 ASC";
		
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
		return $result;
	else
		return FALSE;
}

/**
* @param $user_restrict
* @param $lookup_mode
* @param $all_checked
*/
function fetch_status_type_rs($user_restrict=FALSE, $lookup_mode=FALSE, $all_checked=FALSE)
{
	global $HTTP_SESSION_VARS;
	
	if($lookup_mode)
		$query = "SELECT sst.s_status_type as value, sst.description as display, sst.img ";
	else
		$query = "SELECT sst.s_status_type, sst.description, sst.img ";
	
	if($all_checked)
		$query .= ", 'Y' as checked_ind ";
		
	$query .= "FROM s_status_type sst ";
	
	if($user_restrict)
	{
		$user_type_r = get_min_user_type_r($HTTP_SESSION_VARS['user_type']);
		if(is_not_empty_array($user_type_r))
			$in_clause = format_sql_in_clause($user_type_r);
		if(strlen($in_clause)>0)
		{
			$query .= "WHERE ".
				" ( (LENGTH(IFNULL(sst.min_display_user_type,'')) = 0 OR ".
				" sst.min_display_user_type IN(".$in_clause.")) OR ".
				" (LENGTH(IFNULL(sst.min_create_user_type,'')) = 0 OR ".
				" sst.min_create_user_type IN(".$in_clause.")) ) ";
		}
	}
	
	$query .= " ORDER BY s_status_type ASC";
	
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
		return $result;
	else
		return FALSE;
}

function fetch_whatsnew_status_type_rs()
{
	global $HTTP_SESSION_VARS;
	
	$query = "SELECT sst.s_status_type, sst.description, sst.img ".
			"FROM s_status_type sst ".
			"WHERE sst.closed_ind <> 'Y' ";
	
	$user_type_r = get_min_user_type_r($HTTP_SESSION_VARS['user_type']);
	if(is_not_empty_array($user_type_r))
		$in_clause = format_sql_in_clause($user_type_r);
	if(strlen($in_clause)>0)
	{
		$query .= "AND (LENGTH(IFNULL(sst.min_display_user_type,'')) = 0 OR ".
				" sst.min_display_user_type IN($in_clause) ) ";
	}
	
	$query .= " ORDER BY s_status_type ASC";
	
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
		return $result;
	else
		return FALSE;
}

/*
* @param $s_status_type
*/
function fetch_status_type_r($s_status_type, $full_record=TRUE)
{
	$query = "SELECT s_status_type, description, img";
	
	if($full_record)
		$query .= ", insert_ind, update_ind, delete_ind, min_display_user_type, min_create_user_type, new_owner_instance_ind, new_not_owner_instance_ind, borrow_ind, status_comment_ind, default_ind, closed_ind ";
	
	$query .= " FROM s_status_type ".
			"WHERE s_status_type = '$s_status_type' ".
			"LIMIT 0,1";
	 
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
	{
    	$found = mysql_fetch_array($result, MYSQL_ASSOC);
		mysql_free_result($result);
		return $found;
	}
	else
		return FALSE;
}

function fetch_status_type_col($s_status_type, $column)
{
	$query = "SELECT $column FROM s_status_type WHERE s_status_type = '$s_status_type'";
	$result = run_opendb_query($query);
	if ($result && mysql_num_rows($result)>0)
	{
		$found = mysql_fetch_array($result, MYSQL_ASSOC);
		if ($found)
		{
			mysql_free_result($result);
			return $found[$column];
		}
	}
	//else
	return FALSE;
}


/*
* New instance of existing item
* 
* NOT USED CURRENTLY!!!
*/
/*function fetch_newinstance_status_type_rs($item_id, $owner_id)
{
	$user_type_r = get_min_user_type_r(fetch_user_type($owner_id));
	if(is_not_empty_array($user_type_r))
		$in_clause = format_sql_in_clause($user_type_r);
		
	$query = "SELECT DISTINCT sst.s_status_type as value, sst.description as display, sst.img, sst.default_ind as checked_ind ".
			"FROM s_status_type sst ".
			"LEFT JOIN item_instance ii ON ".
			"sst.s_status_type = ii.s_status_type AND ".
			"ii.item_id = '$item_id' AND ".
			"ii.owner_id = '$owner_id' ".
		"WHERE sst.closed_ind <> 'Y' AND ".
			"sst.insert_ind = 'Y' AND ".
			"((ii.instance_no IS NOT NULL AND ".
			"sst.new_owner_instance_ind = 'Y') OR ".
			"(ii.instance_no IS NULL AND ".
			"sst.new_not_owner_instance_ind = 'Y')) AND ".
			"(LENGTH(IFNULL(sst.min_create_user_type,'')) = 0 OR ".
			"sst.min_create_user_type IN($in_clause) ) ";
			"ORDER BY 1 ASC";
		
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
		return $result;
	else
		return FALSE;
}*/

/*function fetch_default_status_type_for_owner($owner_id)
{
	$user_type_r = get_min_user_type_r(fetch_user_type($owner_id));
	if(is_not_empty_array($user_type_r))
		$in_clause = format_sql_in_clause($user_type_r);
		
	$query = "SELECT sst.s_status_type, IF(LENGTH(IFNULL(sst.default_ind,''))>0,sst.default_ind,'N') ".
			"FROM s_status_type sst ".
			"WHERE sst.closed_ind <> 'Y' AND ".
			"sst.insert_ind = 'Y' AND ".
			"(LENGTH(IFNULL(sst.min_create_user_type,'')) = 0 OR ".
			"sst.min_create_user_type IN($in_clause) ) ".
			"LIMIT 0,1 ORDER BY 2 DESC, 1 ASC ";
		
	$result = run_opendb_query($query);
	if($result && mysql_num_rows($result)>0)
	{
		$found = mysql_fetch_array($result, MYSQL_ASSOC);
		if ($found)
		{
			mysql_free_result($result);
			return $found['s_status_type'];
		}
	}
	else
		return FALSE;
}*/
?>